<template>
  <div class="ele-body">
    <a-card style="width: 100%" :bordered="false">
      <template #title>
        <a-space>
          <a-upload
            :before-upload="importFileCity"
            :showUploadList="false"
            accept=".xls,.xlsx,.csv"
          >
            <a-button>市级导入</a-button>
          </a-upload>
          <a-upload
            :before-upload="importFileArea"
            :showUploadList="false"
            accept=".xls,.xlsx,.csv"
          >
            <a-button>县级导入</a-button>
          </a-upload>
        </a-space>
      </template>
      <a-tabs v-model:activeKey="activeKey">
        <a-tab-pane tab="噪声信息" key="noise">
          <noise-bill ref="noise"></noise-bill>
        </a-tab-pane>
      </a-tabs>
    </a-card>
  </div>
</template>

<script>
import XLSX from "xlsx";
import utils from "./utils";
import { Modal } from "ant-design-vue";
import NoiseBill from "./noise-bill.vue";
import { saveFunctionNoiseBill } from "@/api/ecology/noise/function-sound";
export default {
  name: "FunctionCollectIndex",
  components: {
    NoiseBill,
  },
  data() {
    return {
      activeKey: "noise",
    };
  },
  methods: {
    /* 导入本地excel文件 */
    importFileCity(file) {
      const hide = this.$message.loading("导入中..", 0);

      let reader = new FileReader();
      reader.onload = (e) => {
        try {
          let data = new Uint8Array(e.target.result);
          let workbook = XLSX.read(data, {
            type: "array",
          });
          //0.昼间数据 1.夜间数据 2.其他信息
          let sheetNames = workbook.SheetNames;
          // 解析成二维数组
          let aoa = XLSX.utils.sheet_to_json(workbook.Sheets[sheetNames[0]], {
            header: 1,
          });
          let aoa2= XLSX.utils.sheet_to_json(workbook.Sheets[sheetNames[1]], {
            header: 1,
          });
          const reportDate = aoa[1][0].replace(/[^\d]+/g, "-");

          const functionNoiseList = aoa.filter((item) => {
            return item.length >= 15 && item[0] != "年";
          });
         
          const functionNoiseList2 = aoa2.filter(
            (item) => item.length >= 13 &&  item[1] != "点位名称"
          );

          // 解析成对象数组
          const billName = file.name;
          const billData = utils.toObjData(functionNoiseList);
        
          const billData2 = utils.toPlaceData(functionNoiseList2);
          if (!billData || billData.length == 0) {
            hide();
            Modal.error({
              title: "导入失败",
              content: "找不到数据",
            });
            return;
          }

          const tasks = [];
          if (billData.length > 0) {
            // 合并数据信息与其他信息
            billData.forEach((item) => {
              Object.assign(
                item,
                billData2.find((b2Item) => b2Item.place == item.place)
              );
            });
            tasks.push(
              saveFunctionNoiseBill({
                reportTime: new Date(reportDate).getTime(),
                billName: billName,
                regionLevel: "市级",
                functionNoiseList: billData,
              })
            );
          }

          // 上传到服务器
          Promise.all(tasks)
            .then(() => {
              Modal.success({
                title: "导入成功",
                content: `成功导入${billData.length}条数据`,
              });
              this.$refs.noise && this.$refs.noise.reload();
            })
            .catch(() => {
              Modal.error({
                title: "导入失败",
                content: "数据上传出错",
              });
            })
            .finally(() => {
              hide();
            });
        } catch (error) {
          hide();
          Modal.error({
            title: "导入失败",
            content: error.message,
          });
        }
        // console.log(billData);
      };
      reader.readAsArrayBuffer(file);

      return false;
    },
    importFileArea(file) {
      const hide = this.$message.loading("导入中..", 0);

      let reader = new FileReader();

      reader.onload = (e) => {
        try {
          let data = new Uint8Array(e.target.result);
          let workbook = XLSX.read(data, {
            type: "array",
          });
          //0.昼间数据 1.夜间数据 2.其他信息
          let sheetNames = workbook.SheetNames;
          // 解析成二维数组
          let aoa = XLSX.utils.sheet_to_json(workbook.Sheets[sheetNames[0]], {
            header: 1,
          });

          const reportDate = aoa[1][0].replace(/[^\d]+/g, "-");
          const functionNoiseList = aoa.filter((item) => {
            return item.length >= 28 && typeof item[0] != "string";
          });
  
          // 解析成对象数组
          const billName = file.name;
          const billData = utils.toAreaObjData(functionNoiseList);

          if (!billData || billData.length == 0) {
            hide();
            Modal.error({
              title: "导入失败",
              content: "找不到可用数据",
            });

            return;
          }

          if (billData.length > 0) {
            // 上传到服务器
            saveFunctionNoiseBill({
              reportTime: new Date(reportDate).getTime(),
              billName: billName,
              regionLevel: "县级",
              functionNoiseList: billData,
            })
              .then((res) => {
                if (res.data.code == 0) {
                  Modal.success({
                    title: "导入成功",
                    content: `成功导入${billData.length}条数据`,
                  });
                  this.$refs.noise && this.$refs.noise.reload();
                } else {
                  Modal.error({
                    title: "导入失败",
                    content: "数据上传出错",
                  });
                }
              })
              .catch(() => {
                Modal.error({
                  title: "导入失败",
                  content: "数据上传出错",
                });
              })
              .finally(() => {
                hide();
              });
          }
        } catch (error) {
          hide();
          Modal.error({
            title: "导入失败",
            content: error.message,
          });
        }
        // console.log(billData);
      };
      reader.readAsArrayBuffer(file);
      return false;
    },
  },
};
</script>

<style scoped lang="less">
</style>